function callbackOrderPage(orderCode, host, token) {
    let defaultUrl = host + "/shopee/create/?code=" + orderCode;
    if (window.location.href.includes("food.be.com.vn")) {
        const data = window.localStorage.getItem("flutter.user-info-key");
        const userInfo = JSON.parse(JSON.parse(data));
        if (userInfo && userInfo.access_token) {
            window.location.href = (defaultUrl + "&token=" + userInfo.access_token)
            return
        }
        window.location.href = defaultUrl;
    }

    var request = window.indexedDB.open("localforage");
    request.onerror = e => {
        let data = window.localStorage.getItem("localforage/reduxPersist:auth");
        let r = JSON.parse(JSON.parse(data));
        if (r && r.token) {
            window.location.href = (defaultUrl + "&token=" + r.token)
            return
        }
        window.location.href = defaultUrl;
    };
    request.onsuccess = e => {
        var r = e.target.result;
        const t = r.transaction("keyvaluepairs", "readonly");
        let n = t.objectStore("keyvaluepairs").get("reduxPersist:auth");
        n.onsuccess = e => {
            if (e.target.result) {
                let r = JSON.parse(e.target.result);
                window.location.href = (defaultUrl + "&token=" + r.token)
            } else window.location.href = defaultUrl
        }, n.onerror = e => {
            window.location.href = defaultUrl
        }, t.oncomplete = function () {
            r.close()
        }
    };
    return false
}
function updateData() {
    if (window.location.href.includes("food.be.com.vn")) {
        const data = window.localStorage.getItem("flutter.user-info-key");
        const userInfo = JSON.parse(JSON.parse(data));
        var copyText = document.getElementById("shopeeFoodValue");
        copyText.value = userInfo.access_token
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        navigator.clipboard.writeText(copyText.value);
        var element = document.getElementById("shopeeFoodData");
        element.classList.add("modal-show");
        element = document.getElementById("shopeeFoodBackground");
        element.classList.add("modal-show");
        return
    }
    var request = window.indexedDB.open("localforage");
    request.onerror = e => {
        let data = window.localStorage.getItem("localforage/reduxPersist:auth");
        let r = JSON.parse(JSON.parse(data));
        var copyText = document.getElementById("shopeeFoodValue");
        copyText.value = r.token
        copyText.select();
        copyText.setSelectionRange(0, 99999);
        navigator.clipboard.writeText(copyText.value);
        var element = document.getElementById("shopeeFoodData");
        element.classList.add("modal-show");
        element = document.getElementById("shopeeFoodBackground");
        element.classList.add("modal-show");
    };
    var msgLogin = "Hình như bạn chưa đăng nhập. Hãy đăng nhập và thử lại nhé";
    request.onsuccess = e => {
        var r = e.target.result;
        const t = r.transaction("keyvaluepairs", "readonly");
        let n = t.objectStore("keyvaluepairs").get("reduxPersist:auth");
        n.onsuccess = e => {
            if (e.target.result) {
                let r = JSON.parse(e.target.result);
                console.log("ShopeeFood token của bạn là", r.token);
                var copyText = document.getElementById("shopeeFoodValue");
                copyText.value = r.token
                copyText.select();
                copyText.setSelectionRange(0, 99999);
                navigator.clipboard.writeText(copyText.value);
                var element = document.getElementById("shopeeFoodData");
                element.classList.add("modal-show");
                element = document.getElementById("shopeeFoodBackground");
                element.classList.add("modal-show");
            } else alert(msgLogin)
        }, n.onerror = e => {
            alert(msgLogin)
        }, t.oncomplete = function () {
            r.close()
        }
    };
    return false
}

function closePopup() {
    var element = document.getElementById("shopeeFoodData");
    element.classList.remove("modal-show");
    element = document.getElementById("shopeeFoodBackground");
    element.classList.remove("modal-show");
}

function getParameterByName(name, url = window.location.href) {
    name = name.replace(/[\[\]]/g, '\\$&');
    var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}


if (window.location.hostname.includes("shopeefood.vn") || window.location.hostname.includes("food.be.com.vn")) {
    var body = document.getElementsByTagName("body")[0];
    body.innerHTML += `<style>.modal-show{display: block !important;}.modal-hide{display: none}</style>
        <div style="position: fixed; bottom: 10px; left: 10px; max-width: 350px; z-index: 999;">
            <div style="margin-left: 34px; margin-bottom: 31px;">
                <div style="position: relative; overflow: hidden; cursor: pointer; width: 72px; height: 72px;" id="shopeeFoodClicked" >
                    <img src="https://food.tranvu.info/static/uploads/click_me.png" style="width: 56px; height: 55px; object-fit: contain; margin: 8px;">
                </div>
            </div>
        </div>
        <div class="modal" id="shopeeFoodData" tabindex="-1" role="dialog">
        <div id="shopeeFoodBackground" class="" style="overflow: hidden; cursor: pointer;position: absolute;width: 100%;height: 100%;background: #0f0f0f;top: 0px;z-index: 10;opacity: 0.8;display: none"></div>
            <div class="modal-dialog modal-dialog-centered" role="document" style="z-index: 20">
                <div class="modal-content">
                    <div class="modal-header">
                        <h3 class="modal-title">Token bạn cần lấy là</h3>
                        <a href="javascript:void(0)" id="shopeeFoodClose" aria-label="Close" style="font-size: 25px;color: red;">
                            <span aria-hidden="true">&times;</span>
                        </a>
                    </div>
                    <div class="modal-body">
                        <input type="text" id="shopeeFoodValue" class="form-control" onclick="this.focus();this.select();document.execCommand('copy')">
                        <p style="text-align: center"><i>[Đã sao chép vào bộ nhớ đệm]</i></p>
                    </div>
                </div>
            </div>
        </div>`;
    const buttonClick = document.getElementById("shopeeFoodClicked");
    buttonClick.addEventListener("click", updateData);

    const buttonClose = document.getElementById("shopeeFoodClose");
    buttonClose.addEventListener("click", closePopup);

    const buttonBGClose = document.getElementById("shopeeFoodBackground");
    buttonBGClose.addEventListener("click", closePopup);

    var createGroupInterval = setInterval(function () {
        var QRcodeElm = document.getElementsByClassName("utility-restaurant")[0];

        if (QRcodeElm) {
            QRcodeElm.innerHTML += `<div class="utility-item"><div class="utility-content"><a onclick="window.location.href = 'https://food.tranvu.info/shopee/group/?url=' + window.location.href" href="javascript:void()" class="btn" style="height:40px;line-height: 32px;">Tạo nhóm đặt chung</a></div></div>
    `
            clearInterval(createGroupInterval)
        }
    }, 300)
    var orderCode = getParameterByName("data_group");
    var dataCreate = getParameterByName("data_create");
    var host = getParameterByName("host");
    var token = getParameterByName("_token");
    if (!host) {
        host = "https://food.tranvu.info";
    }

    if (orderCode) {
        callbackOrderPage(orderCode, host, token);
    }
}

if (window.location.hostname.includes("tranvu.info") || window.location.hostname.includes("localhost")) {
    let btnCreate = document.getElementById("btn-create-shopee");
    if (btnCreate) {
        let orderCode = getParameterByName("code", btnCreate.href)
        if (orderCode) {
            btnCreate.href = "https://shopeefood.vn/?data_group=" + orderCode + "&host=" + window.location.href.split("/shop")[0]
        }
    }
    let btnCreateFood = document.getElementById("btn-create-befood");
    if (btnCreateFood) {
        let orderCode = getParameterByName("code", btnCreateFood.href)
        if (orderCode) {
            btnCreateFood.href = "https://food.be.com.vn/?data_group=" + orderCode + "&host=" + window.location.href.split("/shop")[0]
        }
    }
}

chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    if (request.action === 'backgroundScriptMessage') {
        sendMessageToWeb(request.payload);
    }
});

function sendMessageToWeb(payload) {
    window.postMessage(
        {type: "FROM_EXTENSION", payload: payload}, "*");
}

window.addEventListener("message", function (event) {
    if (event.source != window)
        return;

    if (event.data.type && (event.data.type == "FROM_PAGE")) {
        chrome.runtime.sendMessage({action: 'contentScriptMessage', payload: event.data.payload});
    }
});

sendMessageToWeb({
    action: 'setExtVersion',
    version: 1006
});
